
#include "recents.h"
#include <qsettings.h>

Recents::Recents() {
	l.clear();
}

Recents::~Recents() {
}

void Recents::add(QString s) {
	qDebug("Recents::add: '%s'", s.utf8().data());

	QStringList::iterator it = l.find(s);
	if (it != l.end()) l.erase(it);
	l.prepend(s);

	if (l.count() > 10) l.erase(l.fromLast());

	qDebug(" * current list:");
	list();
}

int Recents::count() {
	return l.count();
}

QString Recents::item(int n) {
	return l[n];
}

void Recents::list() {
	qDebug("Recents::list");

	for (int n=0; n < count(); n++) {
		qDebug(" * item %d: '%s'", n, item(n).utf8().data() );
	}
}

void Recents::save(QSettings & set) {
	qDebug("Recents::save");

	set.beginGroup( "recent_files");

	set.writeEntry( "items", count() );
	for (int n=0; n < count(); n++) {
		set.writeEntry("entry_" + QString::number(n), item(n) );
	}

	set.endGroup();
}

void Recents::load(QSettings & set) {
	qDebug("Recents::load");

	l.clear();

	set.beginGroup( "recent_files");

	int num_entries = set.readNumEntry( "items", 0 );
	for (int n=0; n < num_entries; n++) {
		QString s = set.readEntry("entry_" + QString::number(n), "" );
		if (!s.isEmpty()) l.append( s );
	}

	set.endGroup();
}
